include vmode.e    -- Setup Graphics Mode
include MDFont.e   -- modified version of Jiri Babor's Famous Font.e v 4.40
include loadfont.e -- Loads Fonts
include palette.e  -- SuperFast Method of changing Dos Palette
include MDMighty.e -- modified version of Pete Eberlein's Famous Mighty.e
include cursors.e  -- Colin Taylor cursors

global constant 
window   = 0,
button   = 1,
sle      = 2,
combo    = 3,
treeview = 4,
listview = 5

global sequence ctrls 
ctrls = {}

                
-- Various Box Styles ------------------------------------------------

global procedure box(integer x1,integer y1,integer x2,integer y2, sequence c)        
	machine_proc(11,{c[3],1,{{x1,y1},{x2,y1},{x2,y2},{x1,y2}}})
	machine_proc(2,{c[1],0,{{x1,y2},{x1,y1},{x2,y1}}})
	machine_proc(2,{c[2],0,{{x1,y2},{x2,y2},{x2,y1}}})
end procedure

global procedure obox(integer x1,integer y1,integer x2,integer y2, sequence c)        
	machine_proc(2,{c[1],0,{{x1,y2},{x1,y1},{x2,y1}}})
	machine_proc(2,{c[2],0,{{x1,y2},{x2,y2},{x2,y1}}})
end procedure
  
global procedure pbox(integer x1, integer y1, integer x2, integer y2, integer c)
	machine_proc(11,{c,1,{{x1,y1},{x2,y1},{x2,y2},{x1,y2}}})
end procedure 

pbox(1,1,640,480,1) -- Clears Screen to 1st Color in Palette
----------------------------------------------------------------------

-- Border ------------------------------------------------------------ 

global procedure border(integer x1, integer y1, integer x2, integer y2, integer tx, integer ty, sequence c)
     machine_proc(11, {c[3], 1, {{x1, y1}, {x2, y1}, {x2, y2}, {x1, y2}}})
     machine_proc(11, {c[4], 1, {{x1+tx,y1+ty},{x2-tx,y1+ty},{x2-tx,y2-ty},{x1+tx,y2-ty}}})
end procedure

----------------------------------------------------------------------


-- Window ------------------------------------------------------------

global integer win_open
win_open = 0

global sequence wz 
wz = {0,0,0,0}               

global procedure Window(integer start, integer down, integer across, integer drop_box, integer b_size, sequence header)
ctrls = {}

mouse_pointer(0)  	
wz = {start,down,across,drop_box}

for x = 6 to 14 do
    machine_proc(11,{x,1,{{start,down},{across,down},{across,down+1},{start,down+1}}})
    down += 1
end for
for i = 14 to 6 by - 1  do
    machine_proc(11,{i,1,{{start,down},{across,down},{across,down+1},{start,down+1}}})
    down += 1
end for
 
border(start,down+1,across,drop_box,b_size,b_size,{0,0,2,3})

down -= 18

select_font(sysa13)       
set_background(CLEAR) set_foreground(35) 
setx(wz[1]+5) sety(wz[2]+4)
write(header)

set_foreground(3) set_background(1)
setx(across-15) sety(down+3)
write(" X ")

obox(across-16,down+2,across-3,down+16,{29,0})
mouse_pointer(1)
end procedure

----------------------------------------------------------------------

-- save_image --------------------------------------------------------
-- ("I think") this might be somewhat faster than save_image
global function image_save(integer x1, integer y1, integer x2, integer y2)
    integer Width, Height    
    sequence save
   
    Width  = x2 - x1 + 1 
    Height = y2 - y1 + 1 

    save = repeat(0, Height)
    
    for x = 1 to Height do
	save[x] = get_pixel({x1, y1, Width})
        y1 += 1
    end for

    return save
end function

----------------------------------------------------------------------

-- Pixel Routine -----------------------------------------------------
-- display_image() w/diff name (plans are for direct screen writes later.)
global procedure image_display(sequence xy, sequence pixels)
    for i = 1 to length(pixels) do
        pixel(pixels[i], xy)
        xy[2] += 1
    end for
end procedure

----------------------------------------------------------------------


include buttons.e
--include sle.e
include ZLoop2.e